-- Author: Ashnal
-- This is a useful function that prevents a CVAR from changing value mid race.
-- To be used with the CV_CALL flag as a cvars func value
-- must be loaded before any MapChange hooks that want to  check updated values
-- I'm also including this in Ashnal Utilities to hopefully head off any order of operations issues

if onlyAdjustableOnLevelChange then return end

local duringMapchange = false
local cvarTempString
local cvarValueTable = {}
local nextCvarValueTable = {}
local function onlyAdjustableOnLevelChange(cvar)
	if cvar.string ~= cvarValueTable[cvar] then
		if cvarValueTable[cvar] == nil then -- This catches the initial set of the cvar on addon load
			cvarValueTable[cvar] = cvar.string
			nextCvarValueTable[cvar] = cvar.string
		else
			print(cvar.name.." will be changed from "..tostring(cvarValueTable[cvar]).." to "..cvar.string.." next round")
			nextCvarValueTable[cvar] = cvar.string
			CV_StealthSet(cvar, cvarValueTable[cvar])
		end
	elseif cvar.string ~= nextCvarValueTable[cvar] then -- I wish this worked ... but the function isn't called if you enter the same value that it is already
		print(cvar.name.." will now remain "..cvar.string.." next round")
		nextCvarValueTable[cvar] = cvar.string
	end
end
addHook("MapChange", function(gamemap) -- Here we do the cvar changes if there's a mismatch
	duringMapchange = true
	for k,v in pairs(nextCvarValueTable) do
		if k.string ~= v then
			print(k.name.." has changed from "..cvarValueTable[k].." to "..v)
			CV_StealthSet(k, v)
		end
		cvarValueTable[k] = v
	end
	duringMapchange = false
end)

rawset(_G, "onlyAdjustableOnLevelChange", onlyAdjustableOnLevelChange)