local S_BOOSTFLAME = S_BOOSTFLAME
local SKINCOLOR_PURPLE = SKINCOLOR_PURPLE
local SKINCOLOR_BLUEBERRY = SKINCOLOR_BLUEBERRY
local SKINCOLOR_FLAME = SKINCOLOR_FLAME
local SKINCOLOR_MOONSLAM = SKINCOLOR_MOONSLAM
local SKINCOLOR_WHITE = SKINCOLOR_WHITE
local S_BOOSTSMOKESPAWNER = S_BOOSTSMOKESPAWNER
local MFE_VERTICALFLIP = MFE_VERTICALFLIP
local MF2_OBJECTFLIP = MF2_OBJECTFLIP
local MT_ROCKETSNEAKER = MT_ROCKETSNEAKER
local MT_BOOSTFLAME = MT_BOOSTFLAME

local P_SpawnMobj = P_SpawnMobj
local FixedMul = FixedMul

local function K_FlipFromObject(mo, master)
	mo.eflags = (mo.eflags & ~MFE_VERTICALFLIP)|(master.eflags & MFE_VERTICALFLIP)
	mo.flags2 = (mo.flags2 & ~MF2_OBJECTFLIP)|(master.flags2 & MF2_OBJECTFLIP)

	if (mo.eflags & MFE_VERTICALFLIP) then
		mo.z = $ + master.height - FixedMul(master.scale, mo.height)
	end
end

states[S_BOOSTFLAME] = {SPR_BOST, FF_FULLBRIGHT|FF_ANIMATE, TICRATE*9999, nil, 6, 1, S_BOOSTFLAME} -- changed to cycle infinitely, will switch in thinker

local stacks, pmo, timer
addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid and mo.target.player 
		or mo.target and mo.target.valid and mo.target.target and mo.target.target.valid and mo.target.target.player) 
	then return end
	
	mo.target.boostflame = mo  -- reverse reference
	mo.target.resetboostflame = false -- we already have one
	
	if mo.target.type == MT_ROCKETSNEAKER then
		pmo = mo.target.target
		timer = pmo.itemsneakertimer
	else
		pmo = mo.target
		timer = max(pmo.itemsneakertimer, pmo.panelsneakertimer)
	end

	-- this bit handles the state switching now, and does it dynamically based on the amount of boost timer left to account for chaining
	if mo.state == S_BOOSTFLAME and timer <= TICRATE/3 then
		mo.state = S_BOOSTSMOKESPAWNER
	elseif mo.state == S_BOOSTSMOKESPAWNER and timer > TICRATE/3 then
		mo.state = S_BOOSTFLAME
	end

	if mo.state == S_BOOSTFLAME then
		if mo.target.type == MT_ROCKETSNEAKER then
			stacks = (mo.target.target.stackedrockets or 0)
		elseif mo.target.player then
			stacks = (mo.target.stackedpanels or 0) + (mo.target.stackedsneakers or 0) - (mo.target.stackedrockets or 0)
		else
			return -- Failsafe
		end	
		mo.colorized = true
		if stacks <= 1 then
			--No change
		elseif stacks == 2 then
			mo.color = SKINCOLOR_BLUEBERRY
		elseif stacks == 3 then
			mo.color = SKINCOLOR_PURPLE
		elseif stacks == 4 then
			mo.color = SKINCOLOR_MOONSLAM
		elseif stacks >= 5 then
			mo.color = SKINCOLOR_WHITE
		end
	end
end, MT_BOOSTFLAME)

local flame, targetscale
local function checkrespawnflame(mo)
	if not mo.valid then return end
	if mo.resetboostflame and not (mo.boostflame and mo.boostflame.valid) then
		if not mo.boostflamespawndelay then
			mo.boostflamespawndelay = true
			return
		end
		flame = P_SpawnMobj(mo.x, mo.y, mo.z, MT_BOOSTFLAME)
		flame.target = mo
		mo.boostflame = flame
		if mo.type == MT_ROCKETSNEAKER then
			targetscale = mo.scale*3/4
			mo.tracer = flame
		else
			targetscale = mo.scale
		end
		flame.scale = targetscale
		flame.destscale = targetscale
		K_FlipFromObject(flame, mo)
		mo.resetboostflame = false
	end
	mo.boostflamespawndelay = false
end

addHook("MobjThinker", checkrespawnflame, MT_PLAYER)
addHook("MobjThinker", checkrespawnflame, MT_ROCKETSNEAKER)