-- Author: Ashnal
-- Boostlib plugin for Fickle's Combiring script

if not BLib then return end
local SetBoost = BLib.SetBoost

local FRACUNIT = FRACUNIT
local BT_BRAKE = BT_BRAKE
local KITEM_SNEAKER = KITEM_SNEAKER
local k_startboost = k_startboost
local k_driftboost = k_driftboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_sneakertimer = k_sneakertimer
local k_itemtype = k_itemtype
local k_itemamount = k_itemamount
local k_driftcharge = k_driftcharge
local k_rocketsneakertimer = k_rocketsneakertimer
local k_floorboost = k_floorboost

local section, special = 2, 6 -- for the map specific panels
local vanillasneakertime = 47
local gamespeedsneakerstrength = { 53740+768, 32768, 17294+768}
local starttime = 6*TICRATE + (3*TICRATE/4)

local tempsneakerstrength
local cv_sneakerstack
local cv_panelstack
local cv_sneakeritemboost
local cv_sneakeritemaccel
local cv_sneakerpanelboost
local cv_sneakerpanelaccel
local cv_driftboost
local cv_invincibilityboost
local cv_invincibilityaccel
local cv_growboost
local cv_growaccel
local cv_growboostmult
local cvinit = false

local p, pks, tmo, tp, tks
addHook("MobjThinker", function(pmo)
	if not pmo.player.combi then return end
	tmo = pmo.player.combi and pmo.player.combi.mo
    tp = tmo and tmo.player
    if tmo == nil or tp == nil then return end
	tks = tp.kartstuff
    p = pmo.player
    pks = p.kartstuff

    if not cvinit then
        cv_sneakerstack = CV_FindVar("blib_sneakerstack")
        cv_panelstack = CV_FindVar("blib_panelstack")
        cv_sneakeritemboost = CV_FindVar("blib_sneakeritemboost")
        cv_sneakeritemaccel = CV_FindVar("blib_sneakeritemaccel")
        cv_sneakerpanelboost = CV_FindVar("blib_sneakerpanelboost")
        cv_sneakerpanelaccel = CV_FindVar("blib_sneakerpanelaccel")
        cv_driftboost = CV_FindVar("blib_driftboost")
        cv_invincibilityboost = CV_FindVar("blib_invincibilityboost")
        cv_invincibilityaccel = CV_FindVar("blib_invincibilityaccel")
        cv_growboost = CV_FindVar("blib_growboost")
        cv_growaccel = CV_FindVar("blib_growaccel")
        cv_growboostmult = CV_FindVar("blib_growboostmult")
        cvinit = true
    end

	-- Determine the outcome of your charge.
	if leveltime == starttime+1 and tks[k_sneakertimer] then
		pmo.naturalpanelsneakertimer = vanillasneakertime
		pmo.panelsneakertimer = tks[k_sneakertimer]
		pmo.stackedpanels = 1
	end

	-- panel sneakers
	-- check for initial boost for chain and stack purposes
	if tks[k_floorboost] then
		if not tmo.BLlastframefloorboost then
			if P_PlayerTouchingSectorSpecial(tp, section, special) then  -- for the map specific panels
				pmo.stackedpanels = min(($ or 0)+1, 3)
			else
				pmo.stackedpanels = min(($ or 0)+1,cv_panelstack.value)
			end
			pmo.resetboostflame = true
		end
		pmo.naturalpanelsneakertimer = vanillasneakertime
		pks[k_sneakertimer] = vanillasneakertime
		pmo.panelsneakertimer = max(BLib.BoostChain(p, "panelsneaker", vanillasneakertime), vanillasneakertime) + 1
	end

	-- apply boost
	if tmo.panelsneakertimer then
		if cv_sneakerpanelboost.value == 0 then
			tempsneakerstrength = gamespeedsneakerstrength[gamespeed+1]
		else
			tempsneakerstrength = cv_sneakerpanelboost.value
		end
		tempsneakerstrength = $ * tmo.stackedpanels
		BLib.SetBoost(p, "panelsneaker", tempsneakerstrength, cv_sneakerpanelaccel.value, nil, true, true, true)
	else
		BLib.SetBoost(p, "panelsneaker")
	end

	-- item sneakers
	-- check for initial boost for chain and stack purposes
	if ((JUICEBOX and JUICEBOX.value) or (tp.BLlastframebutton == 0 and (tp.cmd.buttons & BT_ATTACK))) and
	((tp.BLlastframeitem == KITEM_SNEAKER and tks[k_itemamount] < tp.BLlastframeamount) or
	(tks[k_rocketsneakertimer] < (tmo.BLlastframerocketsneakertimer or 0)-1)) then
		pmo.naturalitemsneakertimer = vanillasneakertime
		pks[k_sneakertimer] = vanillasneakertime
		pmo.itemsneakertimer = max(BLib.BoostChain(p, "itemsneaker", vanillasneakertime), vanillasneakertime) + 1
		pmo.stackedsneakers = min(($ or 0)+1,cv_sneakerstack.value)
		if (tks[k_rocketsneakertimer] < (tmo.BLlastframerocketsneakertimer or 0)-1) then
			pmo.stackedrockets = min(($ or 0)+1,cv_sneakerstack.value)
			if pmo.hnext then 
				pmo.hnext.resetboostflame = true
				if pmo.hnext.hnext then pmo.hnext.hnext.resetboostflame = true end
			end
		else
			pmo.resetboostflame = true
		end
	end

	-- apply boost
	if tmo.itemsneakertimer then
		if cv_sneakeritemboost.value == 0 then
			tempsneakerstrength = gamespeedsneakerstrength[gamespeed+1]
		else
			tempsneakerstrength = cv_sneakeritemboost.value
		end

		tempsneakerstrength = $ * tmo.stackedsneakers
		BLib.SetBoost(p, "itemsneaker", tempsneakerstrength, cv_sneakeritemaccel.value, nil, true, true, true)
	else
		BLib.SetBoost(p, "itemsneaker")
	end

	if tks[k_startboost] then
		BLib.SetBoost(p, "startboost", FRACUNIT/4, FRACUNIT*6, nil, true, true, false)
	else
		BLib.SetBoost(p, "startboost")
	end

	if tks[k_driftboost] and (tmo.BLlastdriftcharge or 0) > tks[k_driftcharge] and (tmo.BLlastdriftcharge or 0) >= K_GetKartDriftSparkValue(tp) then
		pks[k_driftboost] = max(BLib.BoostChain(p, "drift", $), $)
	end

	if tks[k_driftboost] then
		BLib.SetBoost(p, "drift", cv_driftboost.value, FRACUNIT*4, nil, true, true, true)
	else
		BLib.SetBoost(p, "drift")
	end

	if tks[k_invincibilitytimer] then
		BLib.SetBoost(p, "invincibility", cv_invincibilityboost.value, cv_invincibilityaccel.value, nil, true, true, false)
	else
		BLib.SetBoost(p, "invincibility")
	end

	if tks[k_growshrinktimer] > 0 then
		BLib.SetBoost(p, "grow", cv_growboost.value, cv_growaccel.value, 0, false, false, false)
		BLib.SetBoost(p, "growboostmult", 0, 0, cv_growboostmult.value, true, false, false) -- Two separate entries since we want the boostpower to stack but the base speedboost to not stack
	else
		BLib.SetBoost(p, "grow")
		BLib.SetBoost(p, "growboostmult")
	end
end, MT_PLAYER)