-- Author: Ashnal
-- Implements Eggpanic boost as a BoostLib addon
-- Also adds cvars for the boost amount
if not BLib then return end
local SetBoost = BLib.SetBoost

local eggpanic = eggpanic
local k_eggmanexplode = k_eggmanexplode

local prefix = "blib_"
local cv_eggpanicfisrtnerf = CV_RegisterVar({
    name = prefix.."eggpanicfirstnerf",
    defaultvalue = "off",
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff,
})

local cv_eggpanicboost = CV_RegisterVar({
    name = prefix.."eggpanicboost",
    defaultvalue = "0.15", -- If using with Slipstream or say Juicebox, recommend reducing the speed bonus
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX},
})

local cv_eggpanicaccel = CV_RegisterVar({
    name = prefix.."eggpanicaccel",
    defaultvalue = "2.0",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX},
})

local boosttype = "eggpanic"
local pks
addHook("MobjThinker", function(mo)
	if not eggpanic then return end
	
	pks = mo.player.kartstuff

	if not pks[k_eggmanexplode] then mo.BLEPwasinfirst = false end

	if pks[k_eggmanexplode] and not mo.BLlastframeeggbombtimer then
		if pks[k_position] == 1 then mo.BLEPwasinfirst = true end
	end
	
	if pks[k_eggmanexplode] and not (cv_eggpanicfisrtnerf.value and mo.BLEPwasinfirst) then
		SetBoost(mo.player, boosttype, cv_eggpanicboost.value, cv_eggpanicaccel.value, nil, true, true, false)
	else
		SetBoost(mo.player, boosttype)
	end
	
	mo.BLlastframeeggbombtimer = pks[k_eggmanexplode]
end, MT_PLAYER)