-- compatibility for maps that use this
if not BLib then return end
local SetBoost = BLib.SetBoost

local fzero, fzerospeed, dospeed, speed
addHook("MapChange", function(mapnum)
	fzero = mapheaderinfo[mapnum].fzero
	fzerospeed = mapheaderinfo[mapnum].fzerospeed
	dospeed = fzero and fzerospeed
	speed = ((fzerospeed or 0)-100)*FRACUNIT/100
end)

addHook("NetVars", function(net)
	fzero = net($)
	fzerospeed = net($)
	dospeed = net($)
	speed = net($)
end)

local boosttype = "fzerospeed"

local function setspeed(param)
	if dospeed then
		if type(param) == "number" then -- mapchange or mapload
			for p in players.iterate do
				SetBoost(p, boosttype, speed, 0, 0, true, false, false)
			end
		else -- playerspawn
			SetBoost(param, boosttype, speed, 0, 0, true, false, false)
		end
	end
end
addHook("MapChange", setspeed)
addHook("MapLoad", setspeed)
addHook("PlayerSpawn", setspeed)