if not BLib then return end
local SetBoost = BLib.SetBoost

local k_hyudorotimer = k_hyudorotimer

local cvars = {
    blib_hyuudoroboost = {
        flags = CV_NETVAR|CV_FLOAT|CV_CALL,
        defaultvalue = "0.1",
        PossibleValue = {MIN = 0, MAX = INT32_MAX},
        func = onlyAdjustableOnLevelChange
    },
	blib_hyuudoroaccel = {
		flags = CV_NETVAR|CV_FLOAT|CV_CALL,
		defaultvalue = "0.5", -- 1.0 recommended tweak
		PossibleValue = {MIN = 0, MAX = INT32_MAX},
		func = onlyAdjustableOnLevelChange
	}
}

for k,v in pairs(cvars) do
	v.name = k
	v.ref = CV_RegisterVar(v) -- use a script scope local with CV_CALL to keep track of it, it performs better that way
	rawset(_G, k, v.ref)
end

local hyuudoroboost
local hyuudoroaccel
addHook("MapChange", function(gamemap)
    hyuudoroboost = blib_hyuudoroboost.value 
    hyuudoroaccel = blib_hyuudoroaccel.value 
end)
addHook("NetVars", function(net)
    hyuudoroboost = net($)
    hyuudoroaccel = net($)
end)

local boosttype = "hyuu"

-- init the type here, so we don't have to nil check it
local function setspeed(param)
	if type(param) == "number" then -- mapchange or mapload
		for p in players.iterate do
			SetBoost(p, boosttype)
		end
	else -- playerspawn
		SetBoost(param, boosttype)
	end
end
addHook("MapChange", setspeed)
addHook("MapLoad", setspeed)
addHook("PlayerSpawn", setspeed)

local timer, boostentry
addHook("MobjThinker", function(mo)
	timer = mo.player.kartstuff[k_hyudorotimer]
	if timer and not mo.player.BLcustomboosts[boosttype].speedboost then
		SetBoost(mo.player, boosttype, hyuudoroboost, hyuudoroaccel, nil, true, false, false, true, false, true, false)
	elseif not timer and mo.player.BLcustomboosts[boosttype].speedboost then
		SetBoost(mo.player, boosttype)
	end
end, MT_PLAYER)