if not karttrails then rawset(_G, "karttrails", true) else return end

freeslot("MT_BLIBTRAIL")
freeslot("SPR_BTRA")
freeslot("S_BTRA1", "S_BTRA2", "S_BTRA3", "S_BTRA4")

local MT_BLIBTRAIL = MT_BLIBTRAIL
local MFE_VERTICALFLIP = MFE_VERTICALFLIP
local FRACUNIT = FRACUNIT
local FRACBITS = FRACBITS
local ANGLE_135 = ANGLE_135

mobjinfo[MT_BLIBTRAIL] = {
    spawnstate = S_BTRA1,
	height = 7*FRACUNIT,
    flags = MF_DONTENCOREMAP|MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

local kt = true
local cv_kt = CV_RegisterVar({
    name = "kt_enabled",
    defaultvalue = "Off",
	flags = CV_CALL,
    PossibleValue = CV_OnOff,
	func = function(cvar)
		kt = cvar.value
	end
})

local frames = {
	[0] = {
		A,
		B,
		C,
		D
	},
	[1] = {
		A|FF_TRANS20,
		B|FF_TRANS20,
		C|FF_TRANS20,
		D|FF_TRANS40
	}
}

local frameduration = {
	firstset = {
		[0] = 4,
		[1] = 1050
	},
	last = {
		[0] = 4,
		[1] = -1
	}
}

local cv_transparency_default = 0
local cv_infinite_default = 0

local cv_transparency = {["value"] = cv_transparency_default}
local cv_infinite = {["value"] = cv_infinite_default}
local function setstates()
	states[S_BTRA1] = {SPR_BTRA, frames[cv_transparency.value][1], frameduration.firstset[cv_infinite.value], nil, 0, 0, S_BTRA2}
	states[S_BTRA2] = {SPR_BTRA, frames[cv_transparency.value][2], frameduration.firstset[cv_infinite.value], nil, 0, 0, S_BTRA3}
	states[S_BTRA3] = {SPR_BTRA, frames[cv_transparency.value][3], frameduration.firstset[cv_infinite.value], nil, 0, 0, S_BTRA4}
	states[S_BTRA4] = {SPR_BTRA, frames[cv_transparency.value][4], frameduration.last[cv_infinite.value], nil, 0, 0, S_NULL}
end

cv_transparency = CV_RegisterVar({
    name = "kt_transparency",
    defaultvalue = "Off", -- If you touch this you need to change cv_transparency_default to match
	flags = CV_CALL,
    PossibleValue = CV_OnOff,
	func = setstates
})

cv_infinite = CV_RegisterVar({
    name = "kt_infinite",
    defaultvalue = "Off", -- If you touch this you need to change cv_infinite_default to match
	flags = CV_CALL,
    PossibleValue = CV_OnOff,
	func = setstates
})

local fidelity
local cv_fidelity = CV_RegisterVar({
    name = "kt_fidelity",
    defaultvalue = 13,
	flags = CV_CALL,
    PossibleValue = {MIN = 5, MAX = 50},
	func = function(cvar)
		fidelity = cvar.value
	end
})

local effectheight = mobjinfo[MT_BLIBTRAIL].height
local newx,newy,angle,parts,parts2,i,verticalflip,secondx,secondy,secondz,prevparts,firstpart,firstpart1,firstpart2,spawnnum,color
local function TrailThinker(mo)
	if not kt then return end
	if not (mo.player and mo.player.valid and mo.player.speed > 0) then return end
	if not mo.dotrail then 
		mo.prevparts1 = nil
		mo.prevparts2 = nil
		return
	end

	angle = mo.angle
	verticalflip = mo.eflags & MFE_VERTICALFLIP
	spawnnum = FixedDiv(mo.player.speed, FRACUNIT*fidelity)>>FRACBITS

	color = mo.trailcoloroverride or mo.player.skincolor

	for i = 0, 1 do
		newx = mo.x + P_ReturnThrustX(mo, angle + ((i == 0) and -1 or 1)*ANGLE_135, FixedMul(22*FRACUNIT, mo.scale))			
		newy = mo.y + P_ReturnThrustY(mo, angle + ((i == 0) and -1 or 1)*ANGLE_135, FixedMul(22*FRACUNIT, mo.scale))
		parts = P_SpawnMobj(newx, newy, (verticalflip and (mo.z + mo.height - effectheight) or mo.z), MT_BLIBTRAIL)
		parts.target = mo
		parts.angle = angle
		parts.scale = mo.scale
		parts.color = color
		if i == 0 then
			firstpart1 = parts 
		 else
			firstpart2 = parts
		 end
	end
	--print("spawning extras using prev ".."x: "..secondx.." y: "..secondy.." z: "..secondz)
	for i2 = 1, spawnnum do
		for i = 0, 1 do
			if i == 0 then 
				prevparts = mo.prevparts1
				firstpart = firstpart1
			else 
				prevparts = mo.prevparts2
				firstpart = firstpart2
			end
			
			if prevparts and prevparts.valid then 
				--print((i2).."/"..(spawnnum+1))
				secondx = firstpart.x + ((prevparts.x - firstpart.x)/(spawnnum+1)*(i2))
				secondy = firstpart.y + ((prevparts.y - firstpart.y)/(spawnnum+1)*(i2))
				secondz = firstpart.z + ((prevparts.z - firstpart.z)/(spawnnum+1)*(i2))
				parts2 = P_SpawnMobj(secondx, secondy, secondz, MT_BLIBTRAIL)
				--print("firs x: "..firstpart.x.." y: "..firstpart.y.." z: "..firstpart.z)
				--print("calc x: "..secondx.." y: "..secondy.." z: "..secondz)
				--print("prev x: "..prevparts.x.." y: "..prevparts.y.." z: "..prevparts.z)
				parts2.target = mo
				parts2.scale = mo.scale
				parts2.color = color
			end
		end
	end
	
	mo.prevparts1 = firstpart1
	mo.prevparts2 = firstpart2
end

addHook("MobjThinker", TrailThinker, MT_PLAYER)