-- new way of defining boosts
-- needs more options to control vfx and such

if not BLib then return end
local BLib = BLib
local SetBoost = BLib.SetBoost
local BoostChain = BLib.BoostChain

local FRACUNIT = FRACUNIT
local TICRATE = TICRATE
local BT_BRAKE = BT_BRAKE
local BT_ATTACK = BT_ATTACK
local KITEM_SNEAKER = KITEM_SNEAKER
local KITEM_ROCKETSNEAKER = KITEM_ROCKETSNEAKER

local k_startboost = k_startboost
local k_driftboost = k_driftboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_sneakertimer = k_sneakertimer
local k_itemtype = k_itemtype
local k_itemamount = k_itemamount
local k_driftcharge = k_driftcharge
local k_rocketsneakertimer = k_rocketsneakertimer
local k_floorboost = k_floorboost
local k_spinouttimer = k_spinouttimer

local P_PlayerTouchingSectorSpecial = P_PlayerTouchingSectorSpecial
local min = min
local max = max

local cvars = {
    blib_panelstack = {
        flags = CV_NETVAR|CV_CALL,
        defaultvalue = "1",
        PossibleValue = {MIN = 1, MAX = 3},
        func = onlyAdjustableOnLevelChange
    },
    blib_sneakerstack = {
        flags = CV_NETVAR|CV_CALL,
        defaultvalue = "1",
        PossibleValue = {MIN = 1, MAX = 5},
        func = onlyAdjustableOnLevelChange
    },
    -- When this is set to 0, it uses the vanilla values based on gamespeed
    blib_sneakeritemboost = {
        flags = CV_NETVAR|CV_FLOAT|CV_CALL,
        defaultvalue = "0.0", -- If you're on hard speed and want more catchup power, I recommend 0.375, same as invincibility
        PossibleValue = {MIN = 0, MAX = INT32_MAX},
        func = onlyAdjustableOnLevelChange
    },
    blib_sneakeritemaccel = {
        flags = CV_NETVAR|CV_FLOAT|CV_CALL,
        defaultvalue = "8",
        PossibleValue = {MIN = 0, MAX = INT32_MAX},
        func = onlyAdjustableOnLevelChange
    },
    -- When this is set to 0, it uses the vanilla values basedm on gamespeed
    blib_sneakerpanelboost = {
        flags = CV_NETVAR|CV_FLOAT|CV_CALL,
        defaultvalue = 0,
        PossibleValue = {MIN = 0, MAX = INT32_MAX},
        func = onlyAdjustableOnLevelChange
    },
    blib_sneakerpanelaccel = {
        flags = CV_NETVAR|CV_FLOAT|CV_CALL,
        defaultvalue = "8",
        PossibleValue = {MIN = 0, MAX = INT32_MAX},
        func = onlyAdjustableOnLevelChange
    },
    blib_driftboost = {
        flags = CV_NETVAR|CV_FLOAT|CV_CALL,
        defaultvalue = "0.25",
        PossibleValue = {MIN = 0, MAX = INT32_MAX},
        func = onlyAdjustableOnLevelChange
    },
    blib_invincibilityboost = {
        flags = CV_NETVAR|CV_FLOAT|CV_CALL,
        defaultvalue = "0.375",
        PossibleValue = {MIN = 0, MAX = INT32_MAX},
        func = onlyAdjustableOnLevelChange
    },
    blib_invincibilityaccel = {
        flags = CV_NETVAR|CV_FLOAT|CV_CALL,
        defaultvalue = "3.0",
        PossibleValue = {MIN = 0, MAX = INT32_MAX},
        func = onlyAdjustableOnLevelChange
    },
    blib_growboost = {
        flags = CV_NETVAR|CV_FLOAT|CV_CALL,
        defaultvalue = "0.30", -- recommend 0.30 for grow tweaks, vanilla is 0.2
        PossibleValue = {MIN = 0, MAX = INT32_MAX},
        func = onlyAdjustableOnLevelChange
    },
    blib_growaccel = {
        flags = CV_NETVAR|CV_FLOAT|CV_CALL,
        defaultvalue = "0.5", -- recommend 0.50 for grow tweaks, vanilla is 0.0
        PossibleValue = {MIN = 0, MAX = INT32_MAX},
        func = onlyAdjustableOnLevelChange
    },
    blib_growboostmult = {
        flags = CV_NETVAR|CV_FLOAT|CV_CALL,
        defaultvalue = "-0.3", -- recommended for grow tweaks -0.3, vanilla is 0.0
        PossibleValue = {MIN = INT32_MIN, MAX = INT32_MAX},
        func = onlyAdjustableOnLevelChange
    },
    blib_chainoffroadimmunity = {
        flags = CV_NETVAR|CV_CALL,
        defaultvalue = "Off",
        PossibleValue = CV_OnOff,
        func = onlyAdjustableOnLevelChange
    }
}

for k,v in pairs(cvars) do
	v.name = k
	v.ref = CV_RegisterVar(v) -- use a script scope local with CV_CALL to keep track of it, it performs better that way
	rawset(_G, k, v.ref)
end

local panelstack
local sneakerstack
local sneakeritemboost
local sneakeritemaccel
local sneakerpanelboost
local sneakerpanelaccel
local driftboost
local invincibilityboost
local invincibilityaccel
local growboost
local growaccel
local growboostmult
local chainoffroadimmunity
addHook("MapChange", function(gamemap)
    panelstack = blib_panelstack.value 
    sneakerstack = blib_sneakerstack.value 
    sneakeritemboost = blib_sneakeritemboost.value 
	sneakeritemaccel = blib_sneakeritemaccel.value
	sneakerpanelboost = blib_sneakerpanelboost.value
	sneakerpanelaccel = blib_sneakerpanelaccel.value
	driftboost = blib_driftboost.value
	invincibilityboost = blib_invincibilityboost.value
	invincibilityaccel = blib_invincibilityaccel.value
	growboost = blib_growboost.value
	growaccel = blib_growaccel.value
	growboostmult = blib_growboostmult.value
	chainoffroadimmunity = blib_chainoffroadimmunity.value
end)
addHook("NetVars", function(net)
    panelstack = net($)
    sneakerstack = net($)
    sneakeritemboost = net($)
    sneakeritemaccel = net($)
    sneakerpanelboost = net($)
    sneakerpanelaccel = net($)
    driftboost = net($)
    invincibilityboost = net($)
    invincibilityaccel = net($)
    growboost = net($)
    growaccel = net($)
    growboostmult = net($)
    chainoffroadimmunity = net($)
end)

local function Clamp(value, newmin ,newmax)
	return min(newmax,max(newmin,value))
end

local pks, pmo

local panelchainmaxtimer = 75
local function panelchainfunc(player, name, timer)
	pmo = player.mo
	if  timer > pmo.panelsneakertimer then
		pmo.panelsneakertimer = min(timer, panelchainmaxtimer)
		if chainoffroadimmunity then
			pmo.naturalpanelsneakertimer = timer
		end
	end
	return pmo.panelsneakertimer
end
BLib.RegisterChainFunc("chainablepanelsneaker", panelchainfunc)

local function sneakerchainfunc(player, name, timer)
	pmo = player.mo
	if  timer > pmo.itemsneakertimer then
		pmo.itemsneakertimer = timer
		if chainoffroadimmunity then
			pmo.naturalitemsneakertimer = timer
		end
	end
	return pmo.itemsneakertimer
end
BLib.RegisterChainFunc("chainableitemsneaker", sneakerchainfunc)

local function driftchainfunc(player, name, timer)
	pks = player.kartstuff
	if  timer > pks[k_driftboost] then
		pks[k_driftboost] = timer
	end
	return pks[k_driftboost]
end
BLib.RegisterChainFunc("drift", driftchainfunc)

-- boosttype strings for optimization
local chainablepanelsneaker = "chainablepanelsneaker"
local chainableitemsneaker = "chainableitemsneaker"
local panelsneaker = "panelsneaker"
local itemsneaker= "itemsneaker"
local startboost = "startboost"
local drift = "drift"
local invincibility = "invincibility"
local grow = "grow"
local growboostmultname = "growboostmult"

local section, special = 2, 6 -- for the map specific panels
local vanillasneakertime = 47
local gamespeedsneakerstrength = { 53740+768, 32768, 17294+768}
local starttime = 6*TICRATE + (3*TICRATE/4)
local player, tempsneakerstrength
addHook("MobjThinker", function(mo)
	player = mo.player
	pks = mo.player.kartstuff

	-- Determine the outcome of your charge.
	if leveltime == starttime+1 and pks[k_sneakertimer] then
		mo.naturalpanelsneakertimer = vanillasneakertime
		mo.panelsneakertimer = pks[k_sneakertimer]
		mo.stackedpanels = 1
	end

	-- panel sneakers
	-- check for initial boost for chain and stack purposes
	if pks[k_floorboost] then
		if not mo.BLlastframefloorboost then
			if P_PlayerTouchingSectorSpecial(player, section, special) then  -- for the map specific panels
				mo.stackedpanels = min(($ or 0)+1, 3)
			else
				mo.stackedpanels = min(($ or 0)+1,panelstack)
			end
			mo.resetboostflame = true
		end
		mo.naturalpanelsneakertimer = vanillasneakertime
		mo.panelsneakertimer = Clamp(BoostChain(player, chainablepanelsneaker, vanillasneakertime), vanillasneakertime, panelchainmaxtimer) + 1
	end

	-- item sneakers
	-- check for initial boost for chain and stack purposes
	if ((JUICEBOX and JUICEBOX.value and pks[k_stolentimer] > TICRATE/2-2) or (player.BLlastframebutton == 0 and (player.cmd.buttons & BT_ATTACK))) and -- Either you pressed the item button, or you're playing juicebox and were Hyuu'd
	(((player.BLlastframeitem == KITEM_SNEAKER or (player.BLlastframeitem == KITEM_ROCKETSNEAKER and not pks[k_rocketsneakertimer])) and pks[k_itemamount] < player.BLlastframeamount and (not pks[k_roulettetype] and not pks[k_spinouttimer])) or
	(pks[k_rocketsneakertimer] < (mo.BLlastframerocketsneakertimer or 0)-1)) then
		mo.naturalitemsneakertimer = vanillasneakertime
		mo.itemsneakertimer = max(BoostChain(player, chainableitemsneaker, vanillasneakertime), vanillasneakertime) + 1
		mo.stackedsneakers = min(($ or 0)+1,sneakerstack)
		if (pks[k_rocketsneakertimer] < (mo.BLlastframerocketsneakertimer or 0)-1) then
			mo.stackedrockets = min(($ or 0)+1,sneakerstack)
			if mo.hnext then 
				mo.hnext.resetboostflame = true
				if mo.hnext.hnext then mo.hnext.hnext.resetboostflame = true end
			end
		else
			mo.resetboostflame = true
		end
	end

	-- offroad immunity
	if mo.naturalpanelsneakertimer then
		--			  player,     boost name, boost strength, accel strength, boost mult, stackable, stack vfx, chains, offroad immune, sneakerhandling
		SetBoost(player, panelsneaker,              0,              0,        nil,     false,     false,  false,           true,            true)
	else
		SetBoost(player, panelsneaker)
	end

	-- apply boost
	if mo.panelsneakertimer then
		if sneakerpanelboost == 0 then
			tempsneakerstrength = gamespeedsneakerstrength[gamespeed+1]
		else
			tempsneakerstrength = sneakerpanelboost
		end
		if pks[k_spinouttimer] then
			mo.panelsneakertimer = min($, vanillasneakertime)
		end
		
		tempsneakerstrength = $ * mo.stackedpanels
		--			  player,              boost name,      boost strength,             accel strength, boost mult, stackable, stack vfx, chains, offroad immune, sneakerhandling
		SetBoost(player, chainablepanelsneaker, tempsneakerstrength, sneakerpanelaccel,        nil,      true,      true,   true,          false,            true)
	else
		SetBoost(player, chainablepanelsneaker)
	end
	if not mo.panelsneakertimer then mo.stackedpanels = 0 end

	-- offroad immunity
	if mo.naturalitemsneakertimer then
		--			  player,     boost name, boost strength, accel strength, boost mult, stackable, stack vfx, chains, offroad immune, sneakerhandling
		SetBoost(player, itemsneaker,              0,              0,        nil,     false,     false,  false,           true,            true)
	else
		SetBoost(player, itemsneaker)
	end

	-- apply boost
	if mo.itemsneakertimer then
		if sneakeritemboost == 0 then
			tempsneakerstrength = gamespeedsneakerstrength[gamespeed+1]
		else
			tempsneakerstrength = sneakeritemboost
		end
		
		if pks[k_spinouttimer] then
			mo.itemsneakertimer = min($, vanillasneakertime)
		end
		
		tempsneakerstrength = $ * mo.stackedsneakers
		SetBoost(player, chainableitemsneaker, tempsneakerstrength, sneakeritemaccel, nil, true, true, true, false, true)
	else
		SetBoost(player, chainableitemsneaker)
	end

	if not mo.itemsneakertimer then 
		mo.stackedsneakers = 0
		mo.stackedrockets = 0
	end

	if pks[k_startboost] then
		SetBoost(player, startboost, FRACUNIT/4, FRACUNIT*6, nil, true, true, false)
	else
		SetBoost(player, startboost)
	end

	if pks[k_driftboost] and (mo.BLlastdriftcharge or 0) > pks[k_driftcharge] and (mo.BLlastdriftcharge or 0) >= K_GetKartDriftSparkValue(player) then
		pks[k_driftboost] = max(BoostChain(player, drift, $), $)
	end

	if pks[k_driftboost] then
		if pks[k_spinouttimer] then
			pks[k_driftboost] = min($, TICRATE)
		end
		SetBoost(player, drift, driftboost, FRACUNIT*4, nil, true, true, true)
	else
		SetBoost(player, drift)
	end

	if pks[k_invincibilitytimer] then
		SetBoost(player, invincibility, invincibilityboost, invincibilityaccel, nil, true, true, false, true, false)
	else
		SetBoost(player, invincibility)
	end

	if pks[k_growshrinktimer] > 0 then
		SetBoost(player, grow, growboost, growaccel, nil, false, false)
		SetBoost(player, growboostmultname, 0, 0, growboostmult, true, false) -- Two separate entries since we want the boostpower to stack but the base speedboost to not stack
	else
		SetBoost(player, grow)
		SetBoost(player, growboostmultname)
	end	

	player.BLlastframebutton = (player.cmd.buttons & BT_ATTACK) and ($ or 0)+1
	player.BLlastframeitem = pks[k_itemtype]
	player.BLlastframeamount = pks[k_itemamount]
	-- stuff stored on the mo automatically clears on respawn
	mo.BLlastdriftcharge = pks[k_driftcharge]
	mo.BLlastframerocketsneakertimer = pks[k_rocketsneakertimer]
	mo.BLlastframefloorboost = pks[k_floorboost]
	mo.naturalitemsneakertimer = max(0, ($ or 0)-1)
	mo.naturalpanelsneakertimer = max(0, ($ or 0)-1)
	mo.itemsneakertimer = max(0, ($ or 0)-1)
	mo.panelsneakertimer = max(0, ($ or 0)-1)
end, MT_PLAYER)

-- Needed to reset these between maps since the above is a mobjthinker
addHook("MapChange", function(mapnum)
	for player in players.iterate do
		player.BLlastframebutton = 0
		player.BLlastframeitem = 0
		player.BLlastframeamount = 0
	end
end)