-- The stats numbers are recorded in the main library

addHook("ThinkFrame", do
	if not (hm_intermissioncalc and hm_intermissioncalc() and HM_AddAward) then return end
	
	local highestboost, higheststackcount, longestchain = {}, {}, {}
	for p in players.iterate do
		if not p.valid then continue end
		table.insert(highestboost, p)
		table.insert(higheststackcount, p)
		table.insert(longestchain, p)
	end
	
	table.sort(highestboost, function(a,b) return (a.highestboost or 0) > (b.highestboost or 0) end)
	table.sort(higheststackcount, function(a,b) return (a.higheststackcount or 0) > (b.higheststackcount or 0) end)
	table.sort(longestchain, function(a,b) return (a.longestchain or 0) > (b.longestchain or 0) end)
	
	local cv_booststack = CV_FindVar("blib_booststack")
	local cv_boostcahin = CV_FindVar("blib_boostchain")
	
	if cv_boostcahin.value and (longestchain[1] and longestchain[1].longestchain or 0) >= 126 then -- Anything more than a rainbow
		local tics = longestchain[1].longestchain
		local seconds = tics/TICRATE
		local tenths = (tics%TICRATE)*10/TICRATE
		HM_AddAward("\135EXPERT CHAINER","Chained boosts for \133"..seconds.."."..tenths.." \128seconds, for long lasting momentum.", longestchain[1], tics*7/10)
	end
	
	if cv_booststack.value and (higheststackcount[1] and higheststackcount[1].higheststackcount or 0) >= 4 then
		local count = higheststackcount[1].higheststackcount
		HM_AddAward("\135PHAT STACKS","Stacked \133"..count.." \128types of boosts for mad speed.", higheststackcount[1], 19*count)
	end
	
end)